<?php

namespace ShirtigoCockpitPrintfulfillment;

use Shopware\Components\Plugin;
use Shopware\Components\Plugin\Context\InstallContext;
use Shopware\Components\Plugin\Context\UninstallContext;
use Symfony\Component\DependencyInjection\ContainerBuilder;

/**
 * Shopware-Plugin ShirtigoCockpitPrintfulfillment.
 */
class ShirtigoCockpitPrintfulfillment extends Plugin
{

	const FULFILLMENT_SUCCESS_MESSAGE='{"success":true}';

	const PLUGIN_NAME='ShirtigoCockpitPrintfulfillment';

    /**
    * @param ContainerBuilder $container
    */
    public function build(ContainerBuilder $container)
    {
        $container->setParameter('shirtigo_cockpit_fulfillment.plugin_dir', $this->getPath());
        parent::build($container);
    }

	/**
	 * @param InstallContext $context
	 *
	 * @throws \Zend_Db_Adapter_Exception
	 */
    public function install( InstallContext $context ) {

	    parent::install( $context );

	    // We don't need an entry in the menu, so we can deactivate this here.

	    $pluginName=$this->getName();

	    Shopware()->Db()->update('s_core_menu', ['parent' => 999999],"name='$pluginName'");

	    $service=$this->container->get('shopware_attribute.crud_service');
	    $service->update('s_order_attributes','ShirtigoPFJsonData','string');
	    $service->update('s_order_attributes','ShirtigoPFJsonSent','boolean', [], null, false, 0);
    }

    public function uninstall( UninstallContext $context ) {

	    parent::uninstall( $context );

	    $service=$this->container->get('shopware_attribute.crud_service');
	    $service->delete('s_order_attributes', 'ShirtigoPFJsonData');
	    $service->delete('s_order_attributes','ShirtigoPFJsonSent');
    }

	public function activate(Plugin\Context\ActivateContext $context)
	{
		$context->scheduleClearCache( InstallContext::CACHE_LIST_ALL );
	}

	public function deactivate(Plugin\Context\DeactivateContext $context)
	{
		$context->scheduleClearCache( InstallContext::CACHE_LIST_ALL );
	}


}
