<?php

namespace ShirtigoCockpitPrintfulfillment\Subscriber;

use Enlight\Event\SubscriberInterface;
use ShirtigoCockpitPrintfulfillment\Components\Config;
use ShirtigoCockpitPrintfulfillment\Components\FulfillmentCreatorComponent;
use ShirtigoCockpitPrintfulfillment\ShirtigoCockpitPrintfulfillment;
use Shopware\Components\Api\Exception\NotFoundException;
use Shopware\Components\Plugin\ConfigReader;

class Cronjob implements SubscriberInterface {

	private $config;


	public function __construct($pluginName, ConfigReader $configReader=null)
	{

		$this->config=$configReader->getByPluginName($pluginName);

	}


	public static function getSubscribedEvents() {

		return [
			'Shopware_CronJob_SC_Printfulfillment_Create_Fulfillment' => 'createFulfillment',
			'Enlight_Controller_Action_PostDispatch_Frontend_Index' => 'createFulfillment'
		];
	}


	public function createFulfillment() {

        // Prevent Shopware from being blocked if any error occurs here.

        try {

            $userData = Shopware()->Db()->query('SELECT id from s_core_auth where username=?', [$this->config['ShirtigoCockpitPrintfulfillmentAPIUser']])->fetch();

            if (!$userData) {
                throw new NotFoundException('Order-fulfillment on Cockpit not created. The User with the name "' . $this->config['ShirtigoCockpitPrintfulfillmentAPIUser'] . '" could not be found. Please fix the configuration in the plugin-form.');
            }

            $userId = $userData['id'];

            $user = Shopware()->Models()->find('Shopware\Models\User\User', $userId);

            $component = new FulfillmentCreatorComponent($user);

            $jsonDataArray = Shopware()->Db()->query('SELECT id, orderID, shirtigopfjsondata from s_order_attributes where shirtigopfjsonsent=?', [Config::STATUS_REQUEST_JSON_READY])->fetchAll();

            foreach ($jsonDataArray as $num => $dataArray) {

                $attributeId = $dataArray['id'];
                $jsonData = $dataArray['shirtigopfjsondata'];

                if ($component->createShirtigoFulfillment(json_decode($jsonData, true))) {

                    // Store success-marker in JSON-column.

                    Shopware()->Db()->query('UPDATE s_order_attributes SET shirtigopfjsondata=?, shirtigopfjsonsent=? where id=?', [ShirtigoCockpitPrintfulfillment::FULFILLMENT_SUCCESS_MESSAGE, Config::STATUS_REQUEST_JSON_SENT, $attributeId])->execute();

                }

            }
        } catch (\Exception $exception) {
            // Log & Ignore
            Shopware()->Container()->get('pluginlogger')->error($exception->getMessage(), ['exception' => $exception]);
        }
	}

}